#ifndef __SINTATICO_H__
#define __SINTATICO_H__

#include <stdio.h>
#include <string.h>
#include "lexico.h"
#include "token-id.h"

#define FALSE						0
#define TRUE						1
#define ERROR					0
#define SUCCESS				1

#define CMP		"CMP"
#define ART			"ART"
#define LOG		"LOG"
#define PROG		"PROG"
#define FBOOL	"FBOOL"
#define FINT		"FINT"
#define PROC		"PROC"
#define VBOOL	"VBOOL"
#define VINT		"VINT"
#define UNARIO	"UNARIO"
#define VAR			"VAR"
#define FUNC		"FUNC"

lexico Sintatico(char*);
lexico AnalisadorSintatico();
int AnalisaAtribChProcedimento(lexico *);
int AnalisaAtribuicao(lexico *); 
int AnalisaBloco(lexico *);
int AnalisaComandos(lexico *);
int AnalisaComandoSimples(lexico *);
int AnalisaChamadaFuncao(lexico *);
int AnalisaDeclaracaoDeProcedimento(lexico *);
int AnalisaDeclaracaoDeFuncao(lexico *);
int AnalisaExpressao(lexico *);
int AnalisaExpressaoSimples(lexico *);
int AnalisaEnquanto(lexico*);
int AnalisaEscreva(lexico*);
int AnalisaEtVariaveis(lexico *);
int AnalisaLeia(lexico*);
int AnalisaSe(lexico *);
int AnalisaSubRotinas(lexico *);
int AnalisaTipo(lexico *);
int AnalisaVariaveis(lexico *);
int AnalisaTermo(lexico *);
int AnalisaFator(lexico *);
int AnalisaChamadaProcedimento(lexico *);
int ColocaTipoTabela(lexico *);
int PesquisaDeclVarFuncTabela(char *);
int PesquisaDeclVarTabela(char *);
int PesquisaDuplicVarTabela(lexico *);
int ConsultaRotulo(char *);
int ConsultaEndereco(char *);
int ConsultaTipo(lexico *);
int AnalisaExpressaoPosFixa();
bool PesquisaDeclProcTabela(lexico *);
bool PesquisaDeclFuncTabela(lexico *);
void GeraCodigoPosFixo();
void GeraCodigo(int, char *, int, int);
void CloseSintaticoFile();
void Desempilha();

#endif
